public class Counter implements Runnable
{
    private int counter = 0;

    // increment counter by one
    public void run() {
        lock.lock();
        int cnt = counter;
        counter = cnt + 1;
        lock.unlock();
    }

    // current value of counter
    public int counter() {
        return counter;
    }

    private Lock lock = new PetersonAtomicLock();
}
